/***************************************************************************
                          planet.cpp  -  description
                             -------------------
    begin                : Wed Apr 3 2002
    copyright            : (C) 2002 by Michael Andreen
    email                : whale@linux.nu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "planet.h"

using namespace std;

Planet::Planet()
{
	m_sRace = "Planet";
	m_iScore = 0;
}

Planet::~Planet(){
}

//////////////////////////////////////////////////////////////////////////
//
unsigned Planet::planetScore() const
{
	return m_iScore;
}

//////////////////////////////////////////////////////////////////////////
//
void Planet::setPlanetScore(unsigned i)
{
	m_iScore = i;
}

//////////////////////////////////////////////////////////////////////////
//
int Planet::roids(std::string type, int tick = 0) const
{
	// const... I would like [] as for const types: int ticks = m_Roids[type].size();
	
	vector<int>const* roids = 0;
	for (RoidList::const_iterator i = m_Roids.begin(); i != m_Roids.end(); ++i)
	{
		if (i->first == type)
		{
			roids = &i->second;
			break;
		}
	}
	if (roids == 0)
		return 0;

	int ticks = roids->size();

	if( ticks == 0)
		return 0;
	if (ticks < tick)
		return roids->at(ticks);
	return roids->at(tick);
}

//////////////////////////////////////////////////////////////////////////
//
void Planet::setRoids(std::string type, int number)
{
	if (m_Roids[type].size() == 0)
		m_Roids[type].push_back(number);
	m_Roids[type][0] = number;
}


