/***************************************************************************
                          planet.h  -  description
                             -------------------
    begin                : Wed Apr 3 2002
    copyright            : (C) 2002 by Michael Andreen
    email                : whale@linux.nu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLANET_H
#define PLANET_H

#include "fleet.h"

typedef std::map<std::string, std::vector<int> > RoidList;

/**This class is the implementation of a planet.
 *
 * Yes I know.. In real life you wouldn't call a planet a fleet, but this isn't
 * real life, it's a game engine, and in this engine a planet got all the 
 * attributes that a fleet got + some additions, so I think the inheritance
 * is fully legal from a OOP standpoint. If it isn't, then please correct me ;)
  *@author Michael Andreen
  */

class Planet : public Fleet  {
public: 
	Planet();
	virtual ~Planet();

	unsigned planetScore() const;
	void setPlanetScore(unsigned i);

	int roids(std::string type, int tick = 0) const;
	void setRoids(std::string type, int number);

protected:
	unsigned m_iScore;
	RoidList m_Roids;
	
};

#endif
